mongoose = require('mongoose').set('debug', false);
const Schema = mongoose.Schema;

const tools = require('../tools/general');

mongoose.Promise = global.Promise;
mongoose.level = 'F';

// Resolving error Unknown modifier: $pushAll
mongoose.plugin((schema) => {
  schema.options.usePushEach = true;
});

const AuthorSchema = new Schema({
  idapp: {
    type: String,
  },
  name: {
    type: String,
  },
  surname: {
    type: String,
  },
  bio: {
    type: String,
  },
  img: {
    type: String,
  },
});

var Author = (module.exports = mongoose.model('Author', AuthorSchema));

module.exports.getFieldsForSearch = function () {
  return [
    { field: 'name', type: tools.FieldType.string },
    { field: 'surname', type: tools.FieldType.string },
  ];
};

module.exports.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, idapp, params);
};

module.exports.findAllIdApp = async function (idapp) {
  const myfind = { idapp };

  return await Author.find(myfind).sort({ name: 1, surname: 1 }).select({ idapp: 0 }).lean();
};

module.exports
  .createIndexes()
  .then(() => {})
  .catch((err) => {
    throw err;
  });
